# aclnnHardsigmoid&aclnnInplaceHardsigmoid

## 支持的产品型号

- Atlas 训练产品。
- Atlas A2系列产品/Atlas 300I A2推理产品。

## 接口原型

- aclnnHardsigmoid和aclnnInplaceHardsigmoid实现相同的功能，使用区别如下，请根据自身实际场景选择合适的算子。

  - aclnnHardsigmoid：需新建一个输出张量对象存储计算结果。
  - aclnnInplaceHardsigmoid：无需新建输出张量对象，直接在输入张量的内存中存储计算结果。

- 每个算子分为[两段式接口](common/两段式接口.md)，必须先调用“aclnnHardsigmoidGetWorkspaceSize”或者“aclnnInplaceHardsigmoidGetWorkspaceSize”接口获取计算所需workspace大小以及包含了算子计算流程的执行器，再调用“aclnnHardsigmoid”或者“aclnnInplaceHardsigmoid”接口执行计算。

  + `aclnnStatus aclnnHardsigmoidGetWorkspaceSize(const aclTensor *self, aclTensor *out, uint64_t *workspaceSize, aclOpExecutor **opExecutor)`
  + `aclnnStatus aclnnHardsigmoid(void *workspace, uint64_t workspaceSize, const aclrtStream stream, aclOpExecutor *opExecutor)`
  + `aclnnStatus aclnnInplaceHardsigmoidGetWorkspaceSize(const aclTensor *self, uint64_t *workspaceSize, aclOpExecutor **opExecutor)`
  + `aclnnStatus aclnnInplaceHardsigmoid(void *workspace, uint64_t workspaceSize, const aclrtStream stream, aclOpExecutor *opExecutor)`

## 功能描述

+ 激活函数变种，根据公式返回一个新的tensor。结果的形状与输入tensor相同。
+ 计算公式如下：
  $$
  Hardsigmoid(x)=\begin{cases}
  1, & x\gt3 \\
  0, &  x\le -3 \\
  x/6 + 1/2 , & otherwise
  \end{cases}
  $$

## aclnnHardsigmoidGetWorkspaceSize

- **参数说明：**

  + self: Device侧的aclTensor，数据类型支持 FLOAT、FLOAT16、INT32，支持非连续的Tensor，[数据格式](common/数据格式.md)支持ND。
  + out: Device侧的aclTensor，数据类型支持 FLOAT、FLOAT16、INT32，支持非连续的Tensor，[数据格式](common/数据格式.md)支持ND。
  + workspaceSize: 返回用户需要在Device侧申请的workspace大小。
  + executor: 返回op执行器，包含了算子计算流程计算流程。

- **返回值：**

  aclnnStatus： 返回状态码，具体参见[aclnn返回码](common/aclnn返回码.md)。

## aclnnHardsigmoid

- **参数说明：**

  + workspace: 在Device侧申请的workspace内存地址。
  + workspaceSize: 在Device侧申请的workspace大小，由第一段接口aclnnHardsigmoidGetWorkspaceSize获取。
  + stream: 指定执行任务的 AscendCL Stream流。
  + executor: op执行器，包含了算子计算流程。

- **返回值：**

  aclnnStatus： 返回状态码，具体参见[aclnn返回码](common/aclnn返回码.md)。

## aclnnInplaceHardsigmoidGetWorkspaceSize

- **参数说明：**

  + self: Device侧的aclTensor，数据类型支持 FLOAT、FLOAT16、INT32，支持非连续的Tensor，[数据格式](common/数据格式.md)支持ND。
  + workspaceSize: 返回用户需要在Device侧申请的workspace大小。
  + executor: 返回op执行器，包含了算子计算流程计算流程。

- **返回值：**

  aclnnStatus： 返回状态码，具体参见[aclnn返回码](common/aclnn返回码.md)。

## aclnnInplaceHardsigmoid

- **参数说明：**

  + workspace: 在Device侧申请的workspace内存地址。
  + workspaceSize: 在Device侧申请的workspace大小，由第一段接口aclnnAddGetWorkspaceSize获取。
  + stream: 指定执行任务的 AscendCL Stream流。
  + executor: op执行器，包含了算子计算流程。

- **返回值：**

  aclnnStatus： 返回状态码，具体参见[aclnn返回码](common/aclnn返回码.md)。

## 约束与限制

无