### aclnnThresholdBackWard

## 接口原型
- 每个算子分为[两段式接口](common/两段式接口.md)，必须先调用“aclnnXxxGetWorkspaceSize”接口获取计算所需workspace大小以及包含了算子计算流程的执行器，再调用“aclnnXxx”接口执行计算。

- `aclnnStatus aclnnThresholdBackwardGetWorkspaceSize(const aclTensor *grad_output, const aclTensor *self, const aclScalar *threshold, aclTensor *out，uint64_t &workspaceSize, alcOpExecutor **executor)`
- `aclnnStatus aclnnThresholdBackward(void *workspace, uint64_t workspace_size, const aclStream stream, aclOpExecutor *executor)`

## 功能描述

算子功能：完成threshold_forward对应反向
计算公式：

$$
res(i) = gradOutput(i) if self(i) > threshold else 0
$$

#### 接口参数

**接口：**`aclnnThresholdBackwardGetWorkspaceSize`


- grad_output：Device侧的aclTensor，支持数据类型FLOAT、FLOAT16、INT32、INT8、UINT8，支持非连续的Tensor，[数据格式](common/数据格式.md)支持ND |
- self：Device侧的aclTensor，支持数据类型FLOAT、FLOAT16、INT32、INT8、UINT8，支持非连续的Tensor，[数据格式](common/数据格式.md)支持ND |
- threshold：host侧的aclScalar，数据类型为float  |
- out：Device侧的aclTensor，支持数据类型FLOAT、FLOAT16、INT32、INT8、UINT8，支持非连续的Tensor，[数据格式](common/数据格式.md)支持ND  |
- workspaceSize：返回用户需要在Device侧申请的workspace大小。
- executor：返回op执行器，包含了算子计算流程。

输出：

- aclnnStatus：返回状态码，具体参见[aclnn返回码](common/aclnn返回码.md)

```
ACLNN_ERR_PARAM_NULLPTR：1. 传入的self、other、alpha或out是空指针。
ACLNN_ERR_PARAM_INVALID：1. self和other的数据类型和数据格式不在支持的范围之内。
                         2. self和other 无法做数据类型推导。
                         3. 推导出的数据类型无法转换为指定输出out的类型。
                         4. self和other的shape无法做broadcast。
```


**接口：**`aclnnThresholdBackward`

输入：

- workspace：在Device侧申请的workspace内存起址。
- workspace_size：在Device侧申请的workspace大小，由第一段接口aclnnAddGetWorkspaceSize获取。
- stream：指定执行任务的 AscendCL Stream流。
- executor：op执行器，包含了算子计算流程。

输出：

- aclnnStatus：返回状态码，具体参见[aclnn返回码](common/aclnn返回码.md)
