## aclnnUniqueConsecutive

## 接口原型
- 每个算子分为[两段式接口](common/两段式接口.md)，必须先调用“aclnnXxxGetWorkspaceSize”接口获取计算所需workspace大小以及包含了算子计算流程的执行器，再调用“aclnnXxx”接口执行计算。

- `aclnnStatus aclnnUniqueConsecutiveGetWorkspaceSize(const aclTensor *self, bool returnInverse, bool returnCounts, int dim, aclTensor *valueOut, aclTensor *inverseOut, aclTensor *countsOut, uint64_t *workspaceSize, aclOpExecutor **executor)`
- `aclnnStatus aclnnUniqueConsecutive(void *workspace, uint64_t workspaceSize, aclOpExecutor *executor, aclrtStream stream)`

## 功能描述

算子功能：去除每一个元素后的重复元素。当dim不为空时，去除对应维度上的每一个张量后的重复张量。

#### 接口参数

**接口：**`aclnnUniqueConsecutiveGetWorkspaceSize`

输入：

- self (aclTensor*, 计算输入)：数据类型支持FLOAT、FLOAT16、DOUBLE、INT8、INT16、INT32、INT64、UINT8、UINT16、UINT32、UINT64、COMPLEX64、COMPLEX128、BOOL，[数据格式](common/数据格式.md)支持ND。
- returnInverse (bool, 计算输入): 表示是否返回self中各元素在valueOut中对应元素的位置下标，True时返回，False时不返回。
- returnCounts: (bool, 计算输入) 表示是否返回valueOut中各元素在self中连续重复出现的次数，True时返回，False时不返回。
- dim (int, 计算输入): 表示进行去重的维度。
- valueOut (aclTensor*，计算输出): 第一个输出张量，返回消除连续重复元素后的结果，数据类型支持FLOAT、FLOAT16、DOUBLE、INT8、INT16、INT32、INT64、UINT8、UINT16、UINT32、UINT64、COMPLEX64、COMPLEX128、BOOL，[数据格式](common/数据格式.md)支持ND。
- inverseOut (aclTensor*，计算输出): 第二个输出张量，当returnInverse为True时有意义，返回self中各元素在valueOut中对应元素的位置下标，数据类型支持INT64，[数据格式](common/数据格式.md)支持ND。
- countsOut (aclTensor*，计算输出): 第三个输出张量，当returnCounts为True时有意义，返回valueOut中各元素在self中连续重复出现的次数，数据类型支持INT64，[数据格式](common/数据格式.md)支持ND。
- workspaceSize (uint64_t*, 出参)：返回用户需要在Device侧申请的workspace大小。
- executor (aclOpExecutor**, 出参)：返回op执行器，包含了算子计算流程。

输出：

- aclnnStatus：返回状态码，具体参见[aclnn返回码](common/aclnn返回码.md)

```
161001(ACLNN_ERR_PARAM_NULLPTR)：1. 传入的 self 或 valueOut 或inverseOut 或 countsOut 是空指针时。
161002(ACLNN_ERR_PARAM_INVALID)：1. self 的数据类型不在支持的范围之内。
                                 2. self 和 valueOut 的数据类型不一致。
                                 3. inverseOut 或 countsOut 的数据类型不在支持的范围之内。
                                 4. inverseOut 和 countsOut 的数据类型不一致。
```

**接口：**`aclnnUniqueConsecutive`

输入：

- workspace：在Device侧申请的workspace内存起址。
- workspaceSize：在Device侧申请的workspace大小，由第一段接口aclnnUniqueConsecutivGetWorkspaceSize获取。
- executor：op执行器，包含了算子计算流程。
- stream：指定执行任务的 AscendCL Stream流。

输出：

- aclnnStatus：返回状态码，具体参见[aclnn返回码](common/aclnn返回码.md)

示例代码：

```cpp

```

