# AscendCL meta接口

本节罗列了单算子API执行接口定义时依赖的一些AscendCL元接口，通过这些元接口可以构建所需的[数据结构](数据结构.md)，如aclTensor、aclScalar、aclIntArray等。

**表 1**  AscendCL meta接口

<table><thead align="left"><tr id="row42201311972"><th class="cellrowborder" valign="top" width="16.59%" id="mcps1.2.6.1.1"><p id="p132201831274"><a name="p132201831274"></a><a name="p132201831274"></a><strong id="b22206311774"><a name="b22206311774"></a><a name="b22206311774"></a>接口</strong>名</p>
</th>
<th class="cellrowborder" valign="top" width="21.85%" id="mcps1.2.6.1.2"><p id="p1622015317718"><a name="p1622015317718"></a><a name="p1622015317718"></a><strong id="b422073111714"><a name="b422073111714"></a><a name="b422073111714"></a>接口定义</strong></p>
</th>
<th class="cellrowborder" valign="top" width="10.54%" id="mcps1.2.6.1.3"><p id="p192201431478"><a name="p192201431478"></a><a name="p192201431478"></a><strong id="b6220131573"><a name="b6220131573"></a><a name="b6220131573"></a>功能说明</strong></p>
</th>
<th class="cellrowborder" valign="top" width="31.03%" id="mcps1.2.6.1.4"><p id="p1322018311719"><a name="p1322018311719"></a><a name="p1322018311719"></a><strong id="b72201131775"><a name="b72201131775"></a><a name="b72201131775"></a>参数说明</strong></p>
</th>
<th class="cellrowborder" valign="top" width="19.99%" id="mcps1.2.6.1.5"><p id="p1922019318712"><a name="p1922019318712"></a><a name="p1922019318712"></a><strong id="b192202310715"><a name="b192202310715"></a><a name="b192202310715"></a>返回值</strong></p>
</th>
</tr>
</thead>
<tbody><tr id="row422083114718"><td class="cellrowborder" valign="top" width="16.59%" headers="mcps1.2.6.1.1 "><p id="p1022014314720"><a name="p1022014314720"></a><a name="p1022014314720"></a>aclCreateTensor</p>
</td>
<td class="cellrowborder" valign="top" width="21.85%" headers="mcps1.2.6.1.2 "><p id="p7220931372"><a name="p7220931372"></a><a name="p7220931372"></a><strong id="b722016314714"><a name="b722016314714"></a><a name="b722016314714"></a>aclTensor *aclCreateTensor(const int64_t *viewDims, uint64_t viewDimsNum, aclDataType dataType, const int64_t *stride, int64_t offset, aclFormat format, const int64_t *storageDims, uint64_t storageDimsNum, void *tensorData)</strong></p>
</td>
<td class="cellrowborder" valign="top" width="10.54%" headers="mcps1.2.6.1.3 "><p id="p622013113711"><a name="p622013113711"></a><a name="p622013113711"></a>创建aclTensor。</p>
</td>
<td class="cellrowborder" valign="top" width="31.03%" headers="mcps1.2.6.1.4 "><a name="ul1222019311777"></a><a name="ul1222019311777"></a><ul id="ul1222019311777"><li>viewDims（输入）：view shape的维度值。</li><li>viewDimsNum（输入）：view shape的维度数。</li><li>dataType（输入）：tensor的数据类型。</li><li>strides（输入）：tensor的view的各个维度步长。</li><li>offset（输入）：tensor首元素相对于storage的偏移。</li><li>format（输入）：tensor的数据排布格式。</li><li>storageDims（输入）：tensor的存储的shape的维度值。</li><li>storageDimsNum（输入）：tensor的存储的shape的维度数。</li><li>tensorData（输入）：tensor在Device侧的存储地址。</li></ul>
</td>
<td class="cellrowborder" valign="top" width="19.99%" headers="mcps1.2.6.1.5 "><p id="p182213311717"><a name="p182213311717"></a><a name="p182213311717"></a>成功则返回创建好的aclTensor，否则返回nullptr。</p>
</td>
</tr>
<tr id="row1221031779"><td class="cellrowborder" valign="top" width="16.59%" headers="mcps1.2.6.1.1 "><p id="p1122117311716"><a name="p1122117311716"></a><a name="p1122117311716"></a>aclDestroyTensor</p>
</td>
<td class="cellrowborder" valign="top" width="21.85%" headers="mcps1.2.6.1.2 "><p id="p15221123116714"><a name="p15221123116714"></a><a name="p15221123116714"></a><strong id="b02212311711"><a name="b02212311711"></a><a name="b02212311711"></a>aclnnStatus aclDestroyTensor(const aclTensor *tensor)</strong></p>
</td>
<td class="cellrowborder" valign="top" width="10.54%" headers="mcps1.2.6.1.3 "><p id="p1622118311979"><a name="p1622118311979"></a><a name="p1622118311979"></a>销毁aclTensor。</p>
</td>
<td class="cellrowborder" valign="top" width="31.03%" headers="mcps1.2.6.1.4 "><p id="p72211231876"><a name="p72211231876"></a><a name="p72211231876"></a>tensor（输入）：需要销毁的tensor指针。</p>
</td>
<td class="cellrowborder" valign="top" width="19.99%" headers="mcps1.2.6.1.5 "><p id="p1122116319714"><a name="p1122116319714"></a><a name="p1122116319714"></a>返回0表示成功，返回其它值表示失败。</p>
</td>
</tr>
<tr id="row1822183119712"><td class="cellrowborder" valign="top" width="16.59%" headers="mcps1.2.6.1.1 "><p id="p122211631474"><a name="p122211631474"></a><a name="p122211631474"></a>aclCreateScalar</p>
</td>
<td class="cellrowborder" valign="top" width="21.85%" headers="mcps1.2.6.1.2 "><p id="p182219311672"><a name="p182219311672"></a><a name="p182219311672"></a><strong id="b622113317712"><a name="b622113317712"></a><a name="b622113317712"></a>aclScalar *aclCreateScalar(void *value, aclDataType dataType)</strong></p>
</td>
<td class="cellrowborder" valign="top" width="10.54%" headers="mcps1.2.6.1.3 "><p id="p82216315711"><a name="p82216315711"></a><a name="p82216315711"></a>创建aclScalar。</p>
</td>
<td class="cellrowborder" valign="top" width="31.03%" headers="mcps1.2.6.1.4 "><a name="ul1722116311172"></a><a name="ul1722116311172"></a><ul id="ul1722116311172"><li>value（输入）：Host侧的scalar类型的指针，其指向的值会作为scalar。</li><li>dataType（输入）：scalar的数据类型。</li></ul>
</td>
<td class="cellrowborder" valign="top" width="19.99%" headers="mcps1.2.6.1.5 "><p id="p7221731276"><a name="p7221731276"></a><a name="p7221731276"></a>成功则返回创建好的aclScalar，否则返回nullptr。</p>
</td>
</tr>
<tr id="row22224313713"><td class="cellrowborder" valign="top" width="16.59%" headers="mcps1.2.6.1.1 "><p id="p12221631374"><a name="p12221631374"></a><a name="p12221631374"></a>aclDestroyScalar</p>
</td>
<td class="cellrowborder" valign="top" width="21.85%" headers="mcps1.2.6.1.2 "><p id="p7222831077"><a name="p7222831077"></a><a name="p7222831077"></a><strong id="b12222163118710"><a name="b12222163118710"></a><a name="b12222163118710"></a>aclnnStatus aclDestroyScalar(const aclScalar *scalar)</strong></p>
</td>
<td class="cellrowborder" valign="top" width="10.54%" headers="mcps1.2.6.1.3 "><p id="p722217311174"><a name="p722217311174"></a><a name="p722217311174"></a>销毁aclScalar。</p>
</td>
<td class="cellrowborder" valign="top" width="31.03%" headers="mcps1.2.6.1.4 "><p id="p82221931678"><a name="p82221931678"></a><a name="p82221931678"></a>scalar（输入）：需要销毁的scalar。</p>
</td>
<td class="cellrowborder" valign="top" width="19.99%" headers="mcps1.2.6.1.5 "><p id="p32225311278"><a name="p32225311278"></a><a name="p32225311278"></a>返回0表示成功，返回其它值表示失败。</p>
</td>
</tr>
<tr id="row13222431770"><td class="cellrowborder" valign="top" width="16.59%" headers="mcps1.2.6.1.1 "><p id="p16222103115710"><a name="p16222103115710"></a><a name="p16222103115710"></a>aclCreateIntArray</p>
</td>
<td class="cellrowborder" valign="top" width="21.85%" headers="mcps1.2.6.1.2 "><p id="p142223312710"><a name="p142223312710"></a><a name="p142223312710"></a><strong id="b922233119715"><a name="b922233119715"></a><a name="b922233119715"></a>aclIntArray *aclCreateIntArray(const int64_t *value, uint64_t size)</strong></p>
</td>
<td class="cellrowborder" valign="top" width="10.54%" headers="mcps1.2.6.1.3 "><p id="p922217315710"><a name="p922217315710"></a><a name="p922217315710"></a>创建aclIntArray。</p>
</td>
<td class="cellrowborder" valign="top" width="31.03%" headers="mcps1.2.6.1.4 "><a name="ul922210311974"></a><a name="ul922210311974"></a><ul id="ul922210311974"><li>value（输入）：Host侧的int64_t类型的指针，其指向的值会赋给Array。</li><li>size（输入）：整型数组的长度。</li></ul>
</td>
<td class="cellrowborder" valign="top" width="19.99%" headers="mcps1.2.6.1.5 "><p id="p72228311974"><a name="p72228311974"></a><a name="p72228311974"></a>成功则返回创建好的aclIntArray，否则返回nullptr。</p>
</td>
</tr>
<tr id="row322211311879"><td class="cellrowborder" valign="top" width="16.59%" headers="mcps1.2.6.1.1 "><p id="p162228311879"><a name="p162228311879"></a><a name="p162228311879"></a>aclDestroyIntArray</p>
</td>
<td class="cellrowborder" valign="top" width="21.85%" headers="mcps1.2.6.1.2 "><p id="p17222193118711"><a name="p17222193118711"></a><a name="p17222193118711"></a><strong id="b1022212319719"><a name="b1022212319719"></a><a name="b1022212319719"></a>aclnnStatus aclDestroyIntArray(const aclIntArray *array)</strong></p>
</td>
<td class="cellrowborder" valign="top" width="10.54%" headers="mcps1.2.6.1.3 "><p id="p7222153119717"><a name="p7222153119717"></a><a name="p7222153119717"></a>销毁aclIntArray。</p>
</td>
<td class="cellrowborder" valign="top" width="31.03%" headers="mcps1.2.6.1.4 "><p id="p92220315712"><a name="p92220315712"></a><a name="p92220315712"></a>array（输入）：需要销毁的aclIntArray。</p>
</td>
<td class="cellrowborder" valign="top" width="19.99%" headers="mcps1.2.6.1.5 "><p id="p102221731571"><a name="p102221731571"></a><a name="p102221731571"></a>返回0表示成功，返回其它值表示失败。</p>
</td>
</tr>
<tr id="row1422217311579"><td class="cellrowborder" valign="top" width="16.59%" headers="mcps1.2.6.1.1 "><p id="p1222531370"><a name="p1222531370"></a><a name="p1222531370"></a>aclCreateFloatArray</p>
</td>
<td class="cellrowborder" valign="top" width="21.85%" headers="mcps1.2.6.1.2 "><p id="p922213112715"><a name="p922213112715"></a><a name="p922213112715"></a><strong id="b1822363114715"><a name="b1822363114715"></a><a name="b1822363114715"></a>aclFloatArray *aclCreateFloatArray(const float *value, uint64_t size)</strong></p>
</td>
<td class="cellrowborder" valign="top" width="10.54%" headers="mcps1.2.6.1.3 "><p id="p4223131870"><a name="p4223131870"></a><a name="p4223131870"></a>创建aclFloatArray。</p>
</td>
<td class="cellrowborder" valign="top" width="31.03%" headers="mcps1.2.6.1.4 "><a name="ul622318311572"></a><a name="ul622318311572"></a><ul id="ul622318311572"><li>value（输入）：Host侧的float类型的指针，其指向的值会赋给Array。</li><li>size（输入）：浮点型数组的长度。</li></ul>
</td>
<td class="cellrowborder" valign="top" width="19.99%" headers="mcps1.2.6.1.5 "><p id="p132236311176"><a name="p132236311176"></a><a name="p132236311176"></a>成功则返回创建好的aclFloatArray，否则返回nullptr。</p>
</td>
</tr>
<tr id="row622318311979"><td class="cellrowborder" valign="top" width="16.59%" headers="mcps1.2.6.1.1 "><p id="p18223431975"><a name="p18223431975"></a><a name="p18223431975"></a>aclDestroyFloatArray</p>
</td>
<td class="cellrowborder" valign="top" width="21.85%" headers="mcps1.2.6.1.2 "><p id="p142239311975"><a name="p142239311975"></a><a name="p142239311975"></a><strong id="b1122314311671"><a name="b1122314311671"></a><a name="b1122314311671"></a>aclnnStatus aclDestroyFloatArray(const aclFloatArray *array)</strong></p>
</td>
<td class="cellrowborder" valign="top" width="10.54%" headers="mcps1.2.6.1.3 "><p id="p13223431971"><a name="p13223431971"></a><a name="p13223431971"></a>销毁aclFloatArray。</p>
</td>
<td class="cellrowborder" valign="top" width="31.03%" headers="mcps1.2.6.1.4 "><p id="p132237311577"><a name="p132237311577"></a><a name="p132237311577"></a>array（输入）：需要销毁的aclFloatArray</p>
</td>
<td class="cellrowborder" valign="top" width="19.99%" headers="mcps1.2.6.1.5 "><p id="p18223331470"><a name="p18223331470"></a><a name="p18223331470"></a>返回0表示成功，返回其它值表示失败。</p>
</td>
</tr>
<tr id="row1622312311476"><td class="cellrowborder" valign="top" width="16.59%" headers="mcps1.2.6.1.1 "><p id="p62234311676"><a name="p62234311676"></a><a name="p62234311676"></a>aclCreateBoolArray</p>
</td>
<td class="cellrowborder" valign="top" width="21.85%" headers="mcps1.2.6.1.2 "><p id="p622311311578"><a name="p622311311578"></a><a name="p622311311578"></a><strong id="b22231317718"><a name="b22231317718"></a><a name="b22231317718"></a>aclBoolArray *aclCreateBoolArray(const bool *value, uint64_t size)</strong></p>
</td>
<td class="cellrowborder" valign="top" width="10.54%" headers="mcps1.2.6.1.3 "><p id="p722303112719"><a name="p722303112719"></a><a name="p722303112719"></a>创建aclBoolArray。</p>
</td>
<td class="cellrowborder" valign="top" width="31.03%" headers="mcps1.2.6.1.4 "><a name="ul722333113715"></a><a name="ul722333113715"></a><ul id="ul722333113715"><li>value（输入）： Host侧的bool类型的指针，其指向的值会赋给Array。</li><li>size（输入）：布尔型数组的长度。</li></ul>
</td>
<td class="cellrowborder" valign="top" width="19.99%" headers="mcps1.2.6.1.5 "><p id="p1322312316717"><a name="p1322312316717"></a><a name="p1322312316717"></a>成功则返回创建好的aclBoolArray，否则返回nullptr。</p>
</td>
</tr>
<tr id="row122231431174"><td class="cellrowborder" valign="top" width="16.59%" headers="mcps1.2.6.1.1 "><p id="p022318318714"><a name="p022318318714"></a><a name="p022318318714"></a>aclDestroyBoolArray</p>
</td>
<td class="cellrowborder" valign="top" width="21.85%" headers="mcps1.2.6.1.2 "><p id="p022313120710"><a name="p022313120710"></a><a name="p022313120710"></a><strong id="b14223831979"><a name="b14223831979"></a><a name="b14223831979"></a>aclnnStatus aclDestroyBoolArray(const aclBoolArray *array)</strong></p>
</td>
<td class="cellrowborder" valign="top" width="10.54%" headers="mcps1.2.6.1.3 "><p id="p322453114713"><a name="p322453114713"></a><a name="p322453114713"></a>销毁aclBoolArray。</p>
</td>
<td class="cellrowborder" valign="top" width="31.03%" headers="mcps1.2.6.1.4 "><p id="p62248319710"><a name="p62248319710"></a><a name="p62248319710"></a>array（输入）：需要销毁的aclBoolArray。</p>
</td>
<td class="cellrowborder" valign="top" width="19.99%" headers="mcps1.2.6.1.5 "><p id="p32243311371"><a name="p32243311371"></a><a name="p32243311371"></a>返回0表示成功，返回其它值表示失败。</p>
</td>
</tr>
<tr id="row1022433118720"><td class="cellrowborder" valign="top" width="16.59%" headers="mcps1.2.6.1.1 "><p id="p1922473117719"><a name="p1922473117719"></a><a name="p1922473117719"></a>aclCreateTensorList</p>
</td>
<td class="cellrowborder" valign="top" width="21.85%" headers="mcps1.2.6.1.2 "><p id="p192246311677"><a name="p192246311677"></a><a name="p192246311677"></a><strong id="b222411314712"><a name="b222411314712"></a><a name="b222411314712"></a>aclTensorList *aclCreateTensorList(const aclTensor *const *value, uint64_t size)</strong></p>
</td>
<td class="cellrowborder" valign="top" width="10.54%" headers="mcps1.2.6.1.3 "><p id="p122241331276"><a name="p122241331276"></a><a name="p122241331276"></a>创建aclTensorList。</p>
</td>
<td class="cellrowborder" valign="top" width="31.03%" headers="mcps1.2.6.1.4 "><p id="p1922473115718"><a name="p1922473115718"></a><a name="p1922473115718"></a>value（输入）： Device侧的aclTensor类型的指针，其指向的值会赋给TensorList。</p>
<p id="p1622420311716"><a name="p1622420311716"></a><a name="p1622420311716"></a>size（输入）：张量列表的长度。</p>
</td>
<td class="cellrowborder" valign="top" width="19.99%" headers="mcps1.2.6.1.5 "><p id="p0224123120711"><a name="p0224123120711"></a><a name="p0224123120711"></a>成功则返回创建好的aclTensorList，否则返回nullptr。</p>
</td>
</tr>
<tr id="row5224631277"><td class="cellrowborder" valign="top" width="16.59%" headers="mcps1.2.6.1.1 "><p id="p112247316720"><a name="p112247316720"></a><a name="p112247316720"></a>aclDestroyTensorList</p>
</td>
<td class="cellrowborder" valign="top" width="21.85%" headers="mcps1.2.6.1.2 "><p id="p822417311477"><a name="p822417311477"></a><a name="p822417311477"></a><strong id="b15224103119710"><a name="b15224103119710"></a><a name="b15224103119710"></a>aclnnStatus aclDestroyTensorList(const aclTensorList *array)</strong></p>
</td>
<td class="cellrowborder" valign="top" width="10.54%" headers="mcps1.2.6.1.3 "><p id="p1622403111717"><a name="p1622403111717"></a><a name="p1622403111717"></a>销毁aclTensorList。</p>
</td>
<td class="cellrowborder" valign="top" width="31.03%" headers="mcps1.2.6.1.4 "><p id="p622418318710"><a name="p622418318710"></a><a name="p622418318710"></a>array（输入）：需要销毁的aclTensorList。</p>
</td>
<td class="cellrowborder" valign="top" width="19.99%" headers="mcps1.2.6.1.5 "><p id="p1622473118716"><a name="p1622473118716"></a><a name="p1622473118716"></a>返回0表示成功，返回其它值表示失败。</p>
</td>
</tr>
<tr id="row1722463117710"><td class="cellrowborder" valign="top" width="16.59%" headers="mcps1.2.6.1.1 "><p id="p22241531375"><a name="p22241531375"></a><a name="p22241531375"></a>aclGetViewShape</p>
</td>
<td class="cellrowborder" valign="top" width="21.85%" headers="mcps1.2.6.1.2 "><p id="p1022517314715"><a name="p1022517314715"></a><a name="p1022517314715"></a><strong id="b12251631676"><a name="b12251631676"></a><a name="b12251631676"></a>aclnnStatus aclGetViewShape(const aclTensor *tensor, int64_t **viewDims, uint64_t *viewDimsNum)</strong></p>
</td>
<td class="cellrowborder" valign="top" width="10.54%" headers="mcps1.2.6.1.3 "><p id="p122258318715"><a name="p122258318715"></a><a name="p122258318715"></a>获取aclTensor的ViewShape。</p>
</td>
<td class="cellrowborder" valign="top" width="31.03%" headers="mcps1.2.6.1.4 "><a name="ul11225331777"></a><a name="ul11225331777"></a><ul id="ul11225331777"><li>tensor（输入）：输入的tensor。</li><li>viewDims（输入）：返回的viewShape的dim值。</li><li>viewDimsNum（输入）：返回的viewShape的dim维度数。</li></ul>
</td>
<td class="cellrowborder" valign="top" width="19.99%" headers="mcps1.2.6.1.5 "><p id="p17225431170"><a name="p17225431170"></a><a name="p17225431170"></a>返回0表示成功，返回其它值表示失败。</p>
</td>
</tr>
<tr id="row12251231573"><td class="cellrowborder" valign="top" width="16.59%" headers="mcps1.2.6.1.1 "><p id="p0225163118711"><a name="p0225163118711"></a><a name="p0225163118711"></a>aclGetViewStrides</p>
</td>
<td class="cellrowborder" valign="top" width="21.85%" headers="mcps1.2.6.1.2 "><p id="p922523111714"><a name="p922523111714"></a><a name="p922523111714"></a><strong id="b1822517311775"><a name="b1822517311775"></a><a name="b1822517311775"></a>aclnnStatus aclGetViewStrides(const aclTensor *tensor, int64_t **stridesValue, uint64_t *stridesNum)</strong></p>
</td>
<td class="cellrowborder" valign="top" width="10.54%" headers="mcps1.2.6.1.3 "><p id="p522514311378"><a name="p522514311378"></a><a name="p522514311378"></a>获取aclTensor的viewStrides。</p>
</td>
<td class="cellrowborder" valign="top" width="31.03%" headers="mcps1.2.6.1.4 "><a name="ul122253311978"></a><a name="ul122253311978"></a><ul id="ul122253311978"><li>tensor（输入）：输入的tensor。</li><li>stridesValue（输入）：返回的viewStrides的值。</li><li>stridesNum（输入）：返回的viewStrides的strides值个数。</li></ul>
</td>
<td class="cellrowborder" valign="top" width="19.99%" headers="mcps1.2.6.1.5 "><p id="p022511311870"><a name="p022511311870"></a><a name="p022511311870"></a>返回0表示成功，返回其它值表示失败。</p>
</td>
</tr>
<tr id="row822513115714"><td class="cellrowborder" valign="top" width="16.59%" headers="mcps1.2.6.1.1 "><p id="p1822513319713"><a name="p1822513319713"></a><a name="p1822513319713"></a>aclGetViewOffset</p>
</td>
<td class="cellrowborder" valign="top" width="21.85%" headers="mcps1.2.6.1.2 "><p id="p4225331977"><a name="p4225331977"></a><a name="p4225331977"></a><strong id="b222583110715"><a name="b222583110715"></a><a name="b222583110715"></a>aclnnStatus aclGetViewOffset(const aclTensor *tensor, int64_t *offset)</strong></p>
</td>
<td class="cellrowborder" valign="top" width="10.54%" headers="mcps1.2.6.1.3 "><p id="p1822617311879"><a name="p1822617311879"></a><a name="p1822617311879"></a>获取aclTensor的viewOffset。</p>
</td>
<td class="cellrowborder" valign="top" width="31.03%" headers="mcps1.2.6.1.4 "><a name="ul152267318716"></a><a name="ul152267318716"></a><ul id="ul152267318716"><li>tensor（输入）：输入的tensor。</li><li>offset（输入）：返回的offset值。</li></ul>
</td>
<td class="cellrowborder" valign="top" width="19.99%" headers="mcps1.2.6.1.5 "><p id="p32261831171"><a name="p32261831171"></a><a name="p32261831171"></a>返回0表示成功，返回其它值表示失败。</p>
</td>
</tr>
<tr id="row1222673111718"><td class="cellrowborder" valign="top" width="16.59%" headers="mcps1.2.6.1.1 "><p id="p132265311073"><a name="p132265311073"></a><a name="p132265311073"></a>aclGetFormat</p>
</td>
<td class="cellrowborder" valign="top" width="21.85%" headers="mcps1.2.6.1.2 "><p id="p1822693111714"><a name="p1822693111714"></a><a name="p1822693111714"></a><strong id="b15226131376"><a name="b15226131376"></a><a name="b15226131376"></a>aclnnStatus aclGetFormat(const aclTensor *tensor, aclFormat *format)</strong></p>
</td>
<td class="cellrowborder" valign="top" width="10.54%" headers="mcps1.2.6.1.3 "><p id="p122269319719"><a name="p122269319719"></a><a name="p122269319719"></a>获取aclTensor的format。</p>
</td>
<td class="cellrowborder" valign="top" width="31.03%" headers="mcps1.2.6.1.4 "><a name="ul19226731471"></a><a name="ul19226731471"></a><ul id="ul19226731471"><li>tensor（输入）：输入的tensor。</li><li>format（输入）：返回的aclTensor的数据格式。</li></ul>
</td>
<td class="cellrowborder" valign="top" width="19.99%" headers="mcps1.2.6.1.5 "><p id="p922623114720"><a name="p922623114720"></a><a name="p922623114720"></a>返回0表示成功，返回其它值表示失败。</p>
</td>
</tr>
<tr id="row1222653117716"><td class="cellrowborder" valign="top" width="16.59%" headers="mcps1.2.6.1.1 "><p id="p122269311171"><a name="p122269311171"></a><a name="p122269311171"></a>aclGetDataType</p>
</td>
<td class="cellrowborder" valign="top" width="21.85%" headers="mcps1.2.6.1.2 "><p id="p422683115720"><a name="p422683115720"></a><a name="p422683115720"></a><strong id="b1222614317716"><a name="b1222614317716"></a><a name="b1222614317716"></a>aclnnStatus aclGetDataType(const aclTensor *tensor, aclDataType *dataType)</strong></p>
</td>
<td class="cellrowborder" valign="top" width="10.54%" headers="mcps1.2.6.1.3 "><p id="p9226203111718"><a name="p9226203111718"></a><a name="p9226203111718"></a>获取aclTensor的DataType。</p>
</td>
<td class="cellrowborder" valign="top" width="31.03%" headers="mcps1.2.6.1.4 "><a name="ul42264317720"></a><a name="ul42264317720"></a><ul id="ul42264317720"><li>tensor（输入）：输入的tensor。</li><li>dataType（输入）：返回的aclTensor的数据类型。</li></ul>
</td>
<td class="cellrowborder" valign="top" width="19.99%" headers="mcps1.2.6.1.5 "><p id="p5227153111716"><a name="p5227153111716"></a><a name="p5227153111716"></a>返回0表示成功，返回其它值表示失败。</p>
</td>
</tr>
<tr id="row162278310718"><td class="cellrowborder" valign="top" width="16.59%" headers="mcps1.2.6.1.1 "><p id="p1922711311574"><a name="p1922711311574"></a><a name="p1922711311574"></a>aclGetIntArraySize</p>
</td>
<td class="cellrowborder" valign="top" width="21.85%" headers="mcps1.2.6.1.2 "><p id="p1022753113720"><a name="p1022753113720"></a><a name="p1022753113720"></a><strong id="b112273311279"><a name="b112273311279"></a><a name="b112273311279"></a>aclnnStatus aclGetIntArraySize(const aclIntArray *array, uint64_t *size)</strong></p>
</td>
<td class="cellrowborder" valign="top" width="10.54%" headers="mcps1.2.6.1.3 "><p id="p022716316714"><a name="p022716316714"></a><a name="p022716316714"></a>获取aclIntArray的大小。</p>
</td>
<td class="cellrowborder" valign="top" width="31.03%" headers="mcps1.2.6.1.4 "><a name="ul1422763120710"></a><a name="ul1422763120710"></a><ul id="ul1422763120710"><li>array（输入）：输入的aclIntArray。</li><li>size（输入）：返回的长度。</li></ul>
</td>
<td class="cellrowborder" valign="top" width="19.99%" headers="mcps1.2.6.1.5 "><p id="p1922723118717"><a name="p1922723118717"></a><a name="p1922723118717"></a>返回0表示成功，返回其它值表示失败。</p>
</td>
</tr>
<tr id="row1822713117712"><td class="cellrowborder" valign="top" width="16.59%" headers="mcps1.2.6.1.1 "><p id="p18227431373"><a name="p18227431373"></a><a name="p18227431373"></a>aclGetFloatArraySize</p>
</td>
<td class="cellrowborder" valign="top" width="21.85%" headers="mcps1.2.6.1.2 "><p id="p22277313717"><a name="p22277313717"></a><a name="p22277313717"></a><strong id="b3227631872"><a name="b3227631872"></a><a name="b3227631872"></a>aclnnStatus aclGetFloatArraySize(const aclFloatArray *array, uint64_t *size)</strong></p>
</td>
<td class="cellrowborder" valign="top" width="10.54%" headers="mcps1.2.6.1.3 "><p id="p32277311713"><a name="p32277311713"></a><a name="p32277311713"></a>获取aclFloatArray的大小。</p>
</td>
<td class="cellrowborder" valign="top" width="31.03%" headers="mcps1.2.6.1.4 "><a name="ul82271631474"></a><a name="ul82271631474"></a><ul id="ul82271631474"><li>array（输入）：输入的aclFloatArray。</li><li>size（输入）：返回的长度。</li></ul>
</td>
<td class="cellrowborder" valign="top" width="19.99%" headers="mcps1.2.6.1.5 "><p id="p32271731379"><a name="p32271731379"></a><a name="p32271731379"></a>返回0表示成功，返回其它值表示失败。</p>
</td>
</tr>
<tr id="row192282031171"><td class="cellrowborder" valign="top" width="16.59%" headers="mcps1.2.6.1.1 "><p id="p14228331976"><a name="p14228331976"></a><a name="p14228331976"></a>aclGetBoolArraySize</p>
</td>
<td class="cellrowborder" valign="top" width="21.85%" headers="mcps1.2.6.1.2 "><p id="p102286311778"><a name="p102286311778"></a><a name="p102286311778"></a><strong id="b6228031371"><a name="b6228031371"></a><a name="b6228031371"></a>aclnnStatus aclGetBoolArraySize(const aclBoolArray *array, uint64_t *size)</strong></p>
</td>
<td class="cellrowborder" valign="top" width="10.54%" headers="mcps1.2.6.1.3 "><p id="p722820311775"><a name="p722820311775"></a><a name="p722820311775"></a>获取aclBoolArray的大小。</p>
</td>
<td class="cellrowborder" valign="top" width="31.03%" headers="mcps1.2.6.1.4 "><a name="ul72283311276"></a><a name="ul72283311276"></a><ul id="ul72283311276"><li>array（输入）：输入的aclBoolArray。</li><li>size（输入）：返回的长度。</li></ul>
</td>
<td class="cellrowborder" valign="top" width="19.99%" headers="mcps1.2.6.1.5 "><p id="p722817317718"><a name="p722817317718"></a><a name="p722817317718"></a>返回0表示成功，返回其它值表示失败。</p>
</td>
</tr>
<tr id="row522863110719"><td class="cellrowborder" valign="top" width="16.59%" headers="mcps1.2.6.1.1 "><p id="p1022833111717"><a name="p1022833111717"></a><a name="p1022833111717"></a>aclGetTensorListSize</p>
</td>
<td class="cellrowborder" valign="top" width="21.85%" headers="mcps1.2.6.1.2 "><p id="p92281431779"><a name="p92281431779"></a><a name="p92281431779"></a><strong id="b14228931977"><a name="b14228931977"></a><a name="b14228931977"></a>aclnnStatus aclGetTensorListSize(const aclTensorList *tensorList, uint64_t *size)</strong></p>
</td>
<td class="cellrowborder" valign="top" width="10.54%" headers="mcps1.2.6.1.3 "><p id="p122282319716"><a name="p122282319716"></a><a name="p122282319716"></a>获取aclTensorList的大小。</p>
</td>
<td class="cellrowborder" valign="top" width="31.03%" headers="mcps1.2.6.1.4 "><a name="ul132281331879"></a><a name="ul132281331879"></a><ul id="ul132281331879"><li>tensorList（输入）：输入的aclTensorList。</li><li>size（输入）：返回的长度。</li></ul>
</td>
<td class="cellrowborder" valign="top" width="19.99%" headers="mcps1.2.6.1.5 "><p id="p422817311779"><a name="p422817311779"></a><a name="p422817311779"></a>返回0表示成功，返回其它值表示失败。</p>
</td>
</tr>
<tr id="row59751810143017"><td class="cellrowborder" valign="top" width="16.59%" headers="mcps1.2.6.1.1 "><p id="p697591011302"><a name="p697591011302"></a><a name="p697591011302"></a>aclGetStorageShape</p>
</td>
<td class="cellrowborder" valign="top" width="21.85%" headers="mcps1.2.6.1.2 "><p id="p8937852163015"><a name="p8937852163015"></a><a name="p8937852163015"></a><strong id="b1339193814511"><a name="b1339193814511"></a><a name="b1339193814511"></a>aclnnStatus aclGetStorageShape(const aclTensor *tensor, int64_t **storageDims, uint64_t *storageDimsNum)</strong></p>
</td>
<td class="cellrowborder" valign="top" width="10.54%" headers="mcps1.2.6.1.3 "><p id="p1979712324528"><a name="p1979712324528"></a><a name="p1979712324528"></a>取Tensor在内存上的存储shape。</p>
</td>
<td class="cellrowborder" valign="top" width="31.03%" headers="mcps1.2.6.1.4 "><a name="ul16423394525"></a><a name="ul16423394525"></a><ul id="ul16423394525"><li>tensor（输入）：输入的tensor对应的地址。</li><li>storageDims（输出）：表示获取shape的地址。</li><li>storageDimsNum（输出）：表示获取的shape的维度。</li></ul>
</td>
<td class="cellrowborder" valign="top" width="19.99%" headers="mcps1.2.6.1.5 "><p id="p497671013309"><a name="p497671013309"></a><a name="p497671013309"></a>返回0表示成功，返回其它值表示失败。</p>
</td>
</tr>
<tr id="row05061046195716"><td class="cellrowborder" valign="top" width="16.59%" headers="mcps1.2.6.1.1 "><p id="p1850684655716"><a name="p1850684655716"></a><a name="p1850684655716"></a>aclCreateScalarList</p>
</td>
<td class="cellrowborder" valign="top" width="21.85%" headers="mcps1.2.6.1.2 "><p id="p18506046195714"><a name="p18506046195714"></a><a name="p18506046195714"></a><strong id="b1823355152112"><a name="b1823355152112"></a><a name="b1823355152112"></a>aclScalarList *aclCreateScalarList(const aclScalar *const *value, uint64_t size)</strong></p>
</td>
<td class="cellrowborder" valign="top" width="10.54%" headers="mcps1.2.6.1.3 "><p id="p0506124619571"><a name="p0506124619571"></a><a name="p0506124619571"></a>创建aclScalarList。</p>
</td>
<td class="cellrowborder" valign="top" width="31.03%" headers="mcps1.2.6.1.4 "><p id="p854105916216"><a name="p854105916216"></a><a name="p854105916216"></a>value（输入）： Device侧的aclScalar类型的指针，其指向的值会赋给ScalarList。</p>
<p id="p13542595210"><a name="p13542595210"></a><a name="p13542595210"></a>size（输入）：标量列表的长度。</p>
</td>
<td class="cellrowborder" valign="top" width="19.99%" headers="mcps1.2.6.1.5 "><p id="p6506144611578"><a name="p6506144611578"></a><a name="p6506144611578"></a>成功则返回创建好的aclScalarList，否则返回nullptr。</p>
</td>
</tr>
<tr id="row927485065714"><td class="cellrowborder" valign="top" width="16.59%" headers="mcps1.2.6.1.1 "><p id="p927485085718"><a name="p927485085718"></a><a name="p927485085718"></a>aclDestroyScalarList</p>
</td>
<td class="cellrowborder" valign="top" width="21.85%" headers="mcps1.2.6.1.2 "><p id="p2274165015715"><a name="p2274165015715"></a><a name="p2274165015715"></a><strong id="b157407304268"><a name="b157407304268"></a><a name="b157407304268"></a>aclnnStatus aclDestroyScalarList(const aclScalarList *array)</strong></p>
</td>
<td class="cellrowborder" valign="top" width="10.54%" headers="mcps1.2.6.1.3 "><p id="p2274650145712"><a name="p2274650145712"></a><a name="p2274650145712"></a>销毁aclScalarList。</p>
</td>
<td class="cellrowborder" valign="top" width="31.03%" headers="mcps1.2.6.1.4 "><p id="p1827514503571"><a name="p1827514503571"></a><a name="p1827514503571"></a>array（输入）：需要销毁的aclScalarList。</p>
</td>
<td class="cellrowborder" valign="top" width="19.99%" headers="mcps1.2.6.1.5 "><p id="p1427518505576"><a name="p1427518505576"></a><a name="p1427518505576"></a>返回0表示成功，返回其它值表示失败。</p>
</td>
</tr>
<tr id="row1099915316572"><td class="cellrowborder" valign="top" width="16.59%" headers="mcps1.2.6.1.1 "><p id="p39999536578"><a name="p39999536578"></a><a name="p39999536578"></a>aclGetScalarListSize</p>
</td>
<td class="cellrowborder" valign="top" width="21.85%" headers="mcps1.2.6.1.2 "><p id="p1199914535578"><a name="p1199914535578"></a><a name="p1199914535578"></a><strong id="b148455575299"><a name="b148455575299"></a><a name="b148455575299"></a>aclnnStatus aclGetScalarListSize(const aclScalarList *scalarList, uint64_t *size)</strong></p>
</td>
<td class="cellrowborder" valign="top" width="10.54%" headers="mcps1.2.6.1.3 "><p id="p39994539574"><a name="p39994539574"></a><a name="p39994539574"></a>获取aclScalarList的大小。</p>
</td>
<td class="cellrowborder" valign="top" width="31.03%" headers="mcps1.2.6.1.4 "><a name="ul156061822163114"></a><a name="ul156061822163114"></a><ul id="ul156061822163114"><li>scalarList（输入）：输入的aclScalarList。</li><li>size（输入）：返回的长度。</li></ul>
</td>
<td class="cellrowborder" valign="top" width="19.99%" headers="mcps1.2.6.1.5 "><p id="p19991536576"><a name="p19991536576"></a><a name="p19991536576"></a>返回0表示成功，返回其它值表示失败。</p>
</td>
</tr>
<tr id="row1176185715718"><td class="cellrowborder" valign="top" width="16.59%" headers="mcps1.2.6.1.1 "><p id="p87615735716"><a name="p87615735716"></a><a name="p87615735716"></a>aclInitTensor</p>
</td>
<td class="cellrowborder" valign="top" width="21.85%" headers="mcps1.2.6.1.2 "><p id="p11681658134010"><a name="p11681658134010"></a><a name="p11681658134010"></a><strong id="b8892192434112"><a name="b8892192434112"></a><a name="b8892192434112"></a>aclnnStatus aclInitTensor(aclTensor *tensor, const int64_t *viewDims, uint64_t viewDimsNum, aclDataType dataType, const int64_t *stride, int64_t offset, aclFormat format, const int64_t *storageDims, uint64_t storageDimsNum, void *tensorDataAddr)</strong></p>
</td>
<td class="cellrowborder" valign="top" width="10.54%" headers="mcps1.2.6.1.3 "><p id="p17735713577"><a name="p17735713577"></a><a name="p17735713577"></a>初始化给定tensor的参数。</p>
<p id="p24959376580"><a name="p24959376580"></a><a name="p24959376580"></a>当用户想复用已创建aclTensor时，可使用该接口先重置aclTensor的各项属性。</p>
</td>
<td class="cellrowborder" valign="top" width="31.03%" headers="mcps1.2.6.1.4 "><a name="ul811947131110"></a><a name="ul811947131110"></a><ul id="ul811947131110"><li>tensor（输入）：待初始化参数的tensor，通过aclCreateTensor创建。</li><li>viewDims（输入）：view shape的维度值。</li><li>viewDimsNum（输入）：view shape的维度数。</li><li>dataType（输入）：tensor的数据类型。</li><li>stride（输入）：tensor的view的各个维度步长。</li><li>offset（输入）：tensor首元素相对于storage的偏移。</li><li>format（输入）：tensor的数据排布格式。</li><li>storageDims（输入）：tensor的存储的shape的维度值。</li><li>storageDimsNum（输入）：tensor的存储的shape的维度数。</li><li>tensorDataAddr（输入）：tensor在Device侧的存储地址。</li></ul>
</td>
<td class="cellrowborder" valign="top" width="19.99%" headers="mcps1.2.6.1.5 "><p id="p20771657105710"><a name="p20771657105710"></a><a name="p20771657105710"></a>返回0表示成功，返回其它值表示失败。</p>
</td>
</tr>
</tbody>
</table>

