# NN类算子接口（aclnn）

## 基本概念
-   [两段式接口](./context/common/两段式接口.md)
-   [非连续的Tensor](./context/common/非连续的Tensor.md)
-   [broadcast关系](./context/common/broadcast关系.md)
-   [互推导关系](./context/common/互推导关系.md)
-   [互转换关系](./context/common/互转换关系.md)
-   [数据格式](./context/common/数据格式.md)
-   [数据结构](./context/common/数据结构.md)

## 公共接口
-   [acl meta接口](./context/common/acl_meta接口.md)
-   [aclnn base接口](./context/common/aclnn_base接口.md)

##  返回码
[aclnn返回码](./context/common/aclnn返回码.md)

## 功能接口

说明：功能接口描述中关于昇腾产品形态的详细说明可参见[Descsiption_of_Ascend_Product_Form.md](./Descsiption_of_Ascend_Product_Form.md)。

 -   [aclnnAbs](./context/aclnnAbs.md)
 -   [aclnnAcos&aclnnInplaceAcos](./context/aclnnAcos&aclnnInplaceAcos.md)
 -   [aclnnAcosh&aclnnInplaceAcosh](./context/aclnnAcosh&aclnnInplaceAcosh.md)
 -   [aclnnAdaptiveAvgPool2d](./context/aclnnAdaptiveAvgPool2d.md)
 -   [aclnnAdaptiveAvgPool2dBackward](./context/aclnnAdaptiveAvgPool2dBackward.md)
 -   [aclnnAdaptiveMaxPool2d](./context/aclnnAdaptiveMaxPool2d.md)
 -   [aclnnAdd&aclnnInplaceAdd](./context/aclnnAdd&aclnnInplaceAdd.md)
 -   [aclnnAddbmm&aclnnInplaceAddbmm](./context/aclnnAddbmm&aclnnInplaceAddbmm.md)
 -   [aclnnAddcdiv&aclnnInplaceAddcdiv](./context/aclnnAddcdiv&aclnnInplaceAddcdiv.md)
 -   [aclnnAddcmul&aclnnInplaceAddcmul](./context/aclnnAddcmul&aclnnInplaceAddcmul.md)
 -   [aclnnAddmm&aclnnInplaceAddmm](./context/aclnnAddmm&aclnnInplaceAddmm.md)
 -   [aclnnAddmv](./context/aclnnAddmv.md)
 -   [aclnnAddr&aclnnInplaceAddr](./context/aclnnAddr&aclnnInplaceAddr.md)
 -   [aclnnAdds](./context/aclnnAdds.md)
 -   [aclnnAffineGrid](./context/aclnnAffineGrid.md)
 -   [aclnnAll](./context/aclnnAll.md)
 -   [aclnnAmax](./context/aclnnAmax.md)
 -   [aclnnAmin](./context/aclnnAmin.md)
 -   [aclnnAminmax](./context/aclnnAminmax.md)
 -   [aclnnAminmaxAll](./context/aclnnAminmaxAll.md)
 -   [aclnnAminmaxDim](./context/aclnnAminmaxDim.md)
 -   [aclnnAny](./context/aclnnAny.md)
 -   [aclnnArange](./context/aclnnArange.md)
 -   [aclnnArgMax](./context/aclnnArgMax.md)
 -   [aclnnArgMin](./context/aclnnArgMin.md)
 -   [aclnnArgsort](./context/aclnnArgsort.md)
 -   [aclnnAsin](./context/aclnnAsin.md)
 -   [aclnnAsinh&aclnnInplaceAsinh](./context/aclnnAsinh&aclnnInplaceAsinh.md)
 -   [aclnnAtan&aclnnInplaceAtan](./context/aclnnAtan&aclnnInplaceAtan.md)
 -   [aclnnAtan2&aclnnInplaceAtan2](./context/aclnnAtan2&aclnnInplaceAtan2.md)
 -   [aclnnAtanh&aclnnInplaceAtanh](./context/aclnnAtanh&aclnnInplaceAtanh.md)
 -   [aclnnAvgPool2d](./context/aclnnAvgPool2d.md)
 -   [aclnnAvgPool2dBackward](./context/aclnnAvgPool2dBackward.md)
 -   [aclnnBaddbmm&aclnnInplaceBaddbmm](./context/aclnnBaddbmm&aclnnInplaceBaddbmm.md)
 -   [aclnnBatchMatMul](./context/aclnnBatchMatMul.md)
 -   [aclnnBatchNorm](./context/aclnnBatchNorm.md)
 -   [aclnnBatchNormBackward](./context/aclnnBatchNormBackward.md)
 -   [aclnnBatchNormElemt](./context/aclnnBatchNormElemt.md)
 -   [aclnnBatchNormElemtBackward](./context/aclnnBatchNormElemtBackward.md)
 -   [aclnnBatchNormGatherStatsWithCounts](./context/aclnnBatchNormGatherStatsWithCounts.md)
 -   [aclnnBatchNormReduceBackward](./context/aclnnBatchNormReduceBackward.md)
 -   [aclnnBatchNormStats](./context/aclnnBatchNormStats.md)
 -   [aclnnBernoulli&aclnnInplaceBernoulli](./context/aclnnBernoulli&aclnnInplaceBernoulli.md)
 -   [aclnnBernoulliTensor&aclnnInplaceBernoulliTensor](./context/aclnnBernoulliTensor&aclnnInplaceBernoulliTensor.md)
 -   [aclnnBinaryCrossEntropy](./context/aclnnBinaryCrossEntropy.md)
 -   [aclnnBinaryCrossEntropyBackward](./context/aclnnBinaryCrossEntropyBackward.md)
 -   [aclnnBinaryCrossEntropyWithLogits](./context/aclnnBinaryCrossEntropyWithLogits.md)
 -   [aclnnBinaryCrossEntropyWithLogitsBackward](./context/aclnnBinaryCrossEntropyWithLogitsBackward.md)
 -   [aclnnBincount](./context/aclnnBincount.md)
 -   [aclnnBitwiseAndScalar](./context/aclnnBitwiseAndScalar.md)
 -   [aclnnBitwiseAndTensor](./context/aclnnBitwiseAndTensor.md)
 -   [aclnnBitwiseNot](./context/aclnnBitwiseNot.md)
 -   [aclnnBitwiseOrScalar&aclnnInplaceBitwiseOrScalar](./context/aclnnBitwiseOrScalar&aclnnInplaceBitwiseOrScalar.md)
 -   [aclnnBitwiseOrTensor&aclnnInplaceBitwiseOrTensor](./context/aclnnBitwiseOrTensor&aclnnInplaceBitwiseOrTensor.md)
 -   [aclnnBitwiseXorScalar&aclnnInplaceBitwiseXorScalar](./context/aclnnBitwiseXorScalar&aclnnInplaceBitwiseXorScalar.md)
 -   [aclnnBitwiseXorTensor&aclnnInplaceBitwiseXorTensor](./context/aclnnBitwiseXorTensor&aclnnInplaceBitwiseXorTensor.md)
 -   [aclnnCast](./context/aclnnCast.md)
 -   [aclnnCat](./context/aclnnCat.md)
 -   [aclnnCeil&aclnnInplaceCeil](./context/aclnnCeil&aclnnInplaceCeil.md)
 -   [aclnnCelu&aclnnInplaceCelu](./context/aclnnCelu&aclnnInplaceCelu.md)
 -   [aclnnChannelShuffle](./context/aclnnChannelShuffle.md)
 -   [aclnnClamp](./context/aclnnClamp.md)
 -   [aclnnClampMax&aclnnInplaceClampMax](./context/aclnnClampMax&aclnnInplaceClampMax.md)
 -   [aclnnClampMaxTensor&aclnnInplaceClampMaxTensor](./context/aclnnClampMaxTensor&aclnnInplaceClampMaxTensor.md)
 -   [aclnnClampMin](./context/aclnnClampMin.md)
 -   [aclnnClampMinTensor&aclnnInplaceClampMinTensor](./context/aclnnClampMinTensor&aclnnInplaceClampMinTensor.md)
 -   [aclnnClampTensor](./context/aclnnClampTensor.md)
 -   [aclnnComplex](./context/aclnnComplex.md)
 -   [aclnnConstantPadNd](./context/aclnnConstantPadNd.md)
 -   [aclnnConvDepthwise2d](./context/aclnnConvDepthwise2d.md)
 -   [aclnnConvolution](./context/aclnnConvolution.md)
 -   [aclnnConvolutionBackward](./context/aclnnConvolutionBackward.md)
 -   [aclnnConvTbc](./context/aclnnConvTbc.md)
 -   [aclnnConvTbcBackward](./context/aclnnConvTbcBackward.md)
 -   [aclnnCos&aclnnInplaceCos](./context/aclnnCos&aclnnInplaceCos.md)
 -   [aclnnCosh](./context/aclnnCosh.md)
 -   [aclnnCtcloss](./context/aclnnCtcloss.md)
 -   [aclnnCtcLossBackward](./context/aclnnCtcLossBackward.md)
 -   [aclnnCummax](./context/aclnnCummax.md)
 -   [aclnnCummin](./context/aclnnCummin.md)
 -   [aclnnCumsum](./context/aclnnCumsum.md)
 -   [aclnnDiag](./context/aclnnDiag.md)
 -   [aclnnDiv&aclnnInplaceDiv](./context/aclnnDiv&aclnnInplaceDiv.md)
 -   [aclnnDivMod&aclnnInplaceDivMod](./context/aclnnDivMod&aclnnInplaceDivMod.md)
 -   [aclnnDivMods&aclnnInplaceDivMods](./context/aclnnDivMods&aclnnInplaceDivMods.md)
 -   [aclnnDivs&aclnnInplaceDivs](./context/aclnnDivs&aclnnInplaceDivs.md)
 -   [aclnnDot](./context/aclnnDot.md)
 -   [aclnnDropout](./context/aclnnDropout.md)
 -   [aclnnDropoutBackward](./context/aclnnDropoutBackward.md)
 -   [aclnnDropoutDoMask](./context/aclnnDropoutDoMask.md)
 -   [aclnnDropoutGenMask](./context/aclnnDropoutGenMask.md)
 -   [aclnnElu&aclnnInplaceElu](./context/aclnnElu&aclnnInplaceElu.md)
 -   [aclnnEluBackward](./context/aclnnEluBackward.md)
 -   [aclnnEmbedding](./context/aclnnEmbedding.md)
 -   [aclnnEmbeddingDenseBackward](./context/aclnnEmbeddingDenseBackward.md)
 -   [aclnnEmbeddingRenorm](./context/aclnnEmbeddingRenorm.md)
 -   [aclnnEqScalar&aclnnInplaceEqScalar](./context/aclnnEqScalar&aclnnInplaceEqScalar.md)
 -   [aclnnEqTensor&aclnnInplaceEqTensor](./context/aclnnEqTensor&aclnnInplaceEqTensor.md)
 -   [aclnnEqual](./context/aclnnEqual.md)
 -   [aclnnErf&aclnnInplaceErf](./context/aclnnErf&aclnnInplaceErf.md)
 -   [aclnnErfc&aclnnInplaceErfc](./context/aclnnErfc&aclnnInplaceErfc.md)
 -   [aclnnErfinv&aclnnInplaceErfinv](./context/aclnnErfinv&aclnnInplaceErfinv.md)
 -   [aclnnExp&aclnnInplaceExp](./context/aclnnExp&aclnnInplaceExp.md)
 -   [aclnnExp2&aclnnInplaceExp2](./context/aclnnExp2&aclnnInplaceExp2.md)
 -   [aclnnExpand](./context/aclnnExpand.md)
 -   [aclnnExpm1&aclnnInplaceExpm1](./context/aclnnExpm1&aclnnInplaceExpm1.md)
 -   [aclnnEye](./context/aclnnEye.md)
 -   [aclnnFlatten](./context/aclnnFlatten.md)
 -   [aclnnFlip](./context/aclnnFlip.md)
 -   [aclnnFloor&aclnnInplaceFloor](./context/aclnnFloor&aclnnInplaceFloor.md)
 -   [aclnnFloorDivide&aclnnInplaceFloorDivide](./context/aclnnFloorDivide&aclnnInplaceFloorDivide.md)
 -   [aclnnFloorDivides&aclnnInplaceFloorDivides](./context/aclnnFloorDivides&aclnnInplaceFloorDivides.md)
 -   [aclnnFmodScalar&aclnnInplaceFmodScalar](./context/aclnnFmodScalar&aclnnInplaceFmodScalar.md)
 -   [aclnnFmodTensor&aclnnInplaceFmodTensor](./context/aclnnFmodTensor&aclnnInplaceFmodTensor.md)
 -   [aclnnFrac&aclnnInplaceFrac](./context/aclnnFrac&aclnnInplaceFrac.md)
 -   [aclnnGather](./context/aclnnGather.md)
 -   [aclnnGatherV2](./context/aclnnGatherV2.md)
 -   [aclnnGcd](./context/aclnnGcd.md)
 -   [aclnnGeGlu](./context/aclnnGeGlu.md)
 -   [aclnnGeGluBackward](./context/aclnnGeGluBackward.md)
 -   [aclnnGelu](./context/aclnnGelu.md)
 -   [aclnnGeluBackward](./context/aclnnGeluBackward.md)
 -   [aclnnGer](./context/aclnnGer.md)
 -   [aclnnGeScalar&aclnnInplaceGeScalar](./context/aclnnGeScalar&aclnnInplaceGeScalar.md)
 -   [aclnnGeTensor&aclnnInplaceGeTensor](./context/aclnnGeTensor&aclnnInplaceGeTensor.md)
 -   [aclnnGlu](./context/aclnnGlu.md)
 -   [aclnnGluBackward](./context/aclnnGluBackward.md)
 -   [aclnnGridSampler2D](./context/aclnnGridSampler2D.md)
 -   [aclnnGridSampler2DBackward](./context/aclnnGridSampler2DBackward.md)
 -   [aclnnGroupNorm](./context/aclnnGroupNorm.md)
 -   [aclnnGtScalar&aclnnInplaceGtScalar](./context/aclnnGtScalar&aclnnInplaceGtScalar.md)
 -   [aclnnGtTensor&aclnnInplaceGtTensor](./context/aclnnGtTensor&aclnnInplaceGtTensor.md)
 -   [aclnnHardshrink](./context/aclnnHardshrink.md)
 -   [aclnnHardshrinkBackward](./context/aclnnHardshrinkBackward.md)
 -   [aclnnHardsigmoid&aclnnInplaceHardsigmoid](./context/aclnnHardsigmoid&aclnnInplaceHardsigmoid.md)
 -   [aclnnHardsigmoidBackward](./context/aclnnHardsigmoidBackward.md)
 -   [aclnnHardswish&aclnnInplaceHardswish](./context/aclnnHardswish&aclnnInplaceHardswish.md)
 -   [aclnnHardswishBackward](./context/aclnnHardswishBackward.md)
 -   [aclnnHardtanh&aclnnInplaceHardtanh](./context/aclnnHardtanh&aclnnInplaceHardtanh.md)
 -   [aclnnHardtanhBackward](./context/aclnnHardtanhBackward.md)
 -   [aclnnHistc](./context/aclnnHistc.md)
 -   [aclnnMatmulCompressDequant](./context/aclnnMatmulCompressDequant.md)
 -   [aclnnIm2colBackward](./context/aclnnIm2colBackward.md)
 -   [aclnnIndex](./context/aclnnIndex.md)
 -   [aclnnIndexAdd](./context/aclnnIndexAdd.md)
 -   [aclnnIndexFillTensor&aclnnInplaceIndexFillTensor](./context/aclnnIndexFillTensor&aclnnInplaceIndexFillTensor.md)
 -   [aclnnInplaceIndexCopy](./context/aclnnInplaceIndexCopy.md)
 -   [aclnnIndexPutImpl](./context/aclnnIndexPutImpl.md)
 -   [aclnnIndexSelect](./context/aclnnIndexSelect.md)
 -   [aclnnInplaceAdds](./context/aclnnInplaceAdds.md)
 -   [aclnnInplaceAsin](./context/aclnnInplaceAsin.md)
 -   [aclnnInplaceBitwiseAndScalar](./context/aclnnInplaceBitwiseAndScalar.md)
 -   [aclnnInplaceBitwiseAndTensor](./context/aclnnInplaceBitwiseAndTensor.md)
 -   [aclnnInplaceCopy](./context/aclnnInplaceCopy.md)
 -   [aclnnInplaceCosh](./context/aclnnInplaceCosh.md)
 -   [aclnnInplaceFillDiagonal](./context/aclnnInplaceFillDiagonal.md)
 -   [aclnnInplaceFillScalar](./context/aclnnInplaceFillScalar.md)
 -   [aclnnInplaceFillTensor](./context/aclnnInplaceFillTensor.md)
 -   [aclnnInplaceFloor](./context/aclnnInplaceFloor.md)
 -   [aclnnInplaceMaskedFillScalar](./context/aclnnInplaceMaskedFillScalar.md)
 -   [aclnnInplaceMaskedFillTensor](./context/aclnnInplaceMaskedFillTensor.md)
 -   [aclnnInplaceMaskedScatter](./context/aclnnInplaceMaskedScatter.md)
 -   [aclnnInplaceNormal](./context/aclnnInplaceNormal.md)
 -   [aclnnInplaceOne](./context/aclnnInplaceOne.md)
 -   [aclnnInplacePut](./context/aclnnInplacePut.md)
 -   [aclnnInplaceRandom](./context/aclnnInplaceRandom.md)
 -   [aclnnInplaceRemainderTensorScalar](./context/aclnnInplaceRemainderTensorScalar.md)
 -   [aclnnInplaceRemainderTensorTensor](./context/aclnnInplaceRemainderTensorTensor.md)
 -   [aclnnInplaceScatterUpdate](./context/aclnnInplaceScatterUpdate.md)
 -   [aclnnInplaceSinc](./context/aclnnInplaceSinc.md)
 -   [aclnnInplaceSub](./context/aclnnInplaceSub.md)
 -   [aclnnInplaceSinh](./context/aclnnInplaceSinh.md)
 -   [aclnnInplaceSubs](./context/aclnnInplaceSubs.md)
 -   [aclnnInplaceTan](./context/aclnnInplaceTan.md)
 -   [aclnnInplaceThreshold](./context/aclnnInplaceThreshold.md)
 -   [aclnnInplaceUniform](./context/aclnnInplaceUniform.md)
 -   [aclnnInplaceZero](./context/aclnnInplaceZero.md)
 -   [aclnnInverse](./context/aclnnInverse.md)
 -   [aclnnIsClose](./context/aclnnIsClose.md)
 -   [aclnnIsFinite](./context/aclnnIsFinite.md)
 -   [aclnnIsInScalarTensor](./context/aclnnIsInScalarTensor.md)
 -   [aclnnIsInTensorScalar](./context/aclnnIsInTensorScalar.md)
 -   [aclnnIsNegInf](./context/aclnnIsNegInf.md)
 -   [aclnnIsPosInf](./context/aclnnIsPosInf.md)
 -   [aclnnKlDiv](./context/aclnnKlDiv.md)
 -   [aclnnKlDivBackward](./context/aclnnKlDivBackward.md)
 -   [aclnnKthvalue](./context/aclnnKthvalue.md)
 -   [aclnnL1Loss](./context/aclnnL1Loss.md)
 -   [aclnnL1LossBackward](./context/aclnnL1LossBackward.md)
 -   [aclnnLayerNorm&aclnnLayerNormWithImplMode](./context/aclnnLayerNorm&aclnnLayerNormWithImplMode.md)
 -   [aclnnLayerNormBackward](./context/aclnnLayerNormBackward.md)
 -   [aclnnLeakyRelu&aclnnInplaceLeakyRelu](./context/aclnnLeakyRelu&aclnnInplaceLeakyRelu.md)
 -   [aclnnLeakyReluBackward](./context/aclnnLeakyReluBackward.md)
 -   [aclnnLerp&aclnnInplaceLerp](./context/aclnnLerp&aclnnInplaceLerp.md)
 -   [aclnnLerps&aclnnInplaceLerps](./context/aclnnLerps&aclnnInplaceLerps.md)
 -   [aclnnLeScalar&aclnnInplaceLeScalar](./context/aclnnLeScalar&aclnnInplaceLeScalar.md)
 -   [aclnnLeTensor&aclnnInplaceLeTensor](./context/aclnnLeTensor&aclnnInplaceLeTensor.md)
 -   [aclnnLinalgCross](./context/aclnnLinalgCross.md)
 -   [aclnnLinalgQr](./context/aclnnLinalgQr.md)
 -   [aclnnLinalgVectorNorm](./context/aclnnLinalgVectorNorm.md)
 -   [aclnnLinspace](./context/aclnnLinspace.md)
 -   [aclnnLog&aclnnInplaceLog](./context/aclnnLog&aclnnInplaceLog.md)
 -   [aclnnLog2&aclnnInplaceLog2](./context/aclnnLog2&aclnnInplaceLog2.md)
 -   [aclnnLog10&aclnnInplaceLog10](./context/aclnnLog10&aclnnInplaceLog10.md)
 -   [aclnnLog1p&aclnnInplaceLog1p](./context/aclnnLog1p&aclnnInplaceLog1p.md)
 -   [aclnnLogAddExp](./context/aclnnLogAddExp.md)
 -   [aclnnLogAddExp2](./context/aclnnLogAddExp2.md)
 -   [aclnnLogdet](./context/aclnnLogdet.md)
 -   [aclnnLogicalAnd&aclnnInplaceLogicalAnd](./context/aclnnLogicalAnd&aclnnInplaceLogicalAnd.md)
 -   [aclnnLogicalNot&aclnnInplaceLogicalNot](./context/aclnnLogicalNot&aclnnInplaceLogicalNot.md)
 -   [aclnnLogicalOr&aclnnInplaceLogicalOr](./context/aclnnLogicalOr&aclnnInplaceLogicalOr.md)
 -   [aclnnLogicalXor](./context/aclnnLogicalXor.md)
 -   [aclnnLogSigmoid](./context/aclnnLogSigmoid.md)
 -   [aclnnLogSigmoidBackward](./context/aclnnLogSigmoidBackward.md)
 -   [aclnnLogSigmoidForward](./context/aclnnLogSigmoidForward.md)
 -   [aclnnLogSoftmax](./context/aclnnLogSoftmax.md)
 -   [aclnnLogSoftmaxBackward](./context/aclnnLogSoftmaxBackward.md)
 -   [aclnnLogSumExp](./context/aclnnLogSumExp.md)
 -   [aclnnLtScalar&aclnnInplaceLtScalar](./context/aclnnLtScalar&aclnnInplaceLtScalar.md)
 -   [aclnnLtTensor&aclnnInplaceLtTensor](./context/aclnnLtTensor&aclnnInplaceLtTensor.md)
 -   [aclnnMaskedSelect](./context/aclnnMaskedSelect.md)
 -   [aclnnMatmul](./context/aclnnMatmul.md)
 -   [aclnnMax](./context/aclnnMax.md)
 -   [aclnnMaxDim](./context/aclnnMaxDim.md)
 -   [aclnnMaximum](./context/aclnnMaximum.md)
 -   [aclnnMaxUnpool2d](./context/aclnnMaxUnpool2d.md)
 -   [aclnnMaxUnpool2dBackward](./context/aclnnMaxUnpool2dBackward.md)
 -   [aclnnMaxUnpool3d](./context/aclnnMaxUnpool3d.md)
 -   [aclnnMaxUnpool3dBackward](./context/aclnnMaxUnpool3dBackward.md)
 -   [aclnnMaxV2](./context/aclnnMaxV2.md)
 -   [aclnnMean](./context/aclnnMean.md)
 -   [aclnnMedian](./context/aclnnMedian.md)
 -   [aclnnMedianDim](./context/aclnnMedianDim.md)
 -   [aclnnMin](./context/aclnnMin.md)
 -   [aclnnMinDim](./context/aclnnMinDim.md)
 -   [aclnnMinimum](./context/aclnnMinimum.md)
 -   [aclnnMish&aclnnInplaceMish](./context/aclnnMish&aclnnInplaceMish.md)
 -   [aclnnMishBackward](./context/aclnnMishBackward.md)
 -   [aclnnMm](./context/aclnnMm.md)
 -   [aclnnMseLoss](./context/aclnnMseLoss.md)
 -   [aclnnMseLossBackward](./context/aclnnMseLossBackward.md)
 -   [aclnnMseLossOut](./context/aclnnMseLossOut.md)
 -   [aclnnMul&aclnnInplaceMul](./context/aclnnMul&aclnnInplaceMul.md)
 -   [aclnnMuls&aclnnInplaceMuls](./context/aclnnMuls&aclnnInplaceMuls.md)
 -   [aclnnMultilabelMarginLoss](./context/aclnnMultilabelMarginLoss.md)
 -   [aclnnMultinomial](./context/aclnnMultinomial.md)
 -   [aclnnMv](./context/aclnnMv.md)
 -   [aclnnNanMedian](./context/aclnnNanMedian.md)
 -   [aclnnNanMedianDim](./context/aclnnNanMedianDim.md)
 -   [aclnnNanToNum&aclnnInplaceNanToNum](./context/aclnnNanToNum&aclnnInplaceNanToNum.md)
 -   [aclnnNeg&aclnnInplaceNeg](./context/aclnnNeg&aclnnInplaceNeg.md)
 -   [aclnnNeScalar&aclnnInplaceNeScalar](./context/aclnnNeScalar&aclnnInplaceNeScalar.md)
 -   [aclnnNeTensor&aclnnInplaceNeTensor](./context/aclnnNeTensor&aclnnInplaceNeTensor.md)
 -   [aclnnNLLLoss](./context/aclnnNLLLoss.md)
 -   [aclnnNLLLossBackward](./context/aclnnNLLLossBackward.md)
 -   [aclnnNLLLoss2d](./context/aclnnNLLLoss2d.md)
 -   [aclnnNLLLoss2dBackward](./context/aclnnNLLLoss2dBackward.md)
 -   [aclnnNonzero](./context/aclnnNonzero.md)
 -   [aclnnNonzeroV2](./context/aclnnNonzeroV2.md)
 -   [aclnnNorm](./context/aclnnNorm.md)
 -   [aclnnNormalFloatFloat](./context/aclnnNormalFloatFloat.md)
 -   [aclnnNormalFloatTensor](./context/aclnnNormalFloatTensor.md)
 -   [aclnnNormalTensorFloat](./context/aclnnNormalTensorFloat.md)
 -   [aclnnNormalTensorTensor](./context/aclnnNormalTensorTensor.md)
 -   [aclnnOneHot](./context/aclnnOneHot.md)
 -   [aclnnPdist](./context/aclnnPdist.md)
 -   [aclnnPdistForward](./context/aclnnPdistForward.md)
 -   [aclnnPermute](./context/aclnnPermute.md)
 -   [aclnnPowScalarTensor](./context/aclnnPowScalarTensor.md)
 -   [aclnnPowTensorScalar&aclnnInplacePowTensorScalar](./context/aclnnPowTensorScalar&aclnnInplacePowTensorScalar.md)
 -   [aclnnPowTensorTensor&aclnnInplacePowTensorTensor](./context/aclnnPowTensorTensor&aclnnInplacePowTensorTensor.md)
 -   [aclnnPrelu](./context/aclnnPrelu.md)
 -   [aclnnPreluBackward](./context/aclnnPreluBackward.md)
 -   [aclnnProd](./context/aclnnProd.md)
 -   [aclnnProdDim](./context/aclnnProdDim.md)
 -   [aclnnQr](./context/aclnnQr.md)
 -   [aclnnQuantMatmul](./context/aclnnQuantMatmul.md)
 -   [aclnnRandperm](./context/aclnnRandperm.md)
 -   [aclnnRange](./context/aclnnRange.md)
 -   [aclnnReal](./context/aclnnReal.md)
 -   [aclnnReciprocal&aclnnInplaceReciprocal](./context/aclnnReciprocal&aclnnInplaceReciprocal.md)
 -   [aclnnReduceNansum](./context/aclnnReduceNansum.md)
 -   [aclnnReduceSum](./context/aclnnReduceSum.md)
 -   [aclnnReflectionPad1d](./context/aclnnReflectionPad1d.md)
 -   [aclnnReflectionPad1dBackward](./context/aclnnReflectionPad1dBackward.md)
 -   [aclnnReflectionPad2d](./context/aclnnReflectionPad2d.md)
 -   [aclnnReflectionPad2dBackward](./context/aclnnReflectionPad2dBackward.md)
 -    [aclnnReflectionPad3d](./context/aclnnReflectionPad3d.md)
 -   [aclnnRelu&aclnnInplaceRelu](./context/aclnnRelu&aclnnInplaceRelu.md)
 -   [aclnnRemainderTensorScalar&aclnnInplaceRemainderTensorScalar](./context/aclnnRemainderTensorScalar&aclnnInplaceRemainderTensorScalar.md)
 -   [aclnnRemainderScalarTensor](./context/aclnnRemainderScalarTensor.md)
 -   [aclnnRemainderTensorTensor&aclnnInplaceRemainderTensorTensor](./context/aclnnRemainderTensorTensor&aclnnInplaceRemainderTensorTensor.md)
 -   [aclnnRenorm&aclnnInplaceRenorm](./context/aclnnRenorm&aclnnInplaceRenorm.md)
 -   [aclnnRepeat](./context/aclnnRepeat.md)
 -   [aclnnRepeatInterleave](./context/aclnnRepeatInterleave.md)
 -   [aclnnRepeatInterleaveInt](./context/aclnnRepeatInterleaveInt.md)
 -   [aclnnRepeatInterleaveIntWithDim](./context/aclnnRepeatInterleaveIntWithDim.md)
 -   [aclnnRepeatInterleaveWithDim](./context/aclnnRepeatInterleaveWithDim.md)
 -   [aclnnRepeatInterleaveTensor](./context/aclnnRepeatInterleaveTensor.md)
 -   [aclnnReplicationPad1d](./context/aclnnReplicationPad1d.md)
 -   [aclnnReplicationPad1dBackward](./context/aclnnReplicationPad1dBackward.md)
 -   [aclnnReplicationPad2d](./context/aclnnReplicationPad2d.md)
 -   [aclnnReplicationPad2dBackward](./context/aclnnReplicationPad2dBackward.md)
 -   [aclnnRoll](./context/aclnnRoll.md)
 -   [aclnnReplicationPad3d](./context/aclnnReplicationPad3d.md)
 -   [aclnnRound&aclnnInplaceRound](./context/aclnnRound&aclnnInplaceRound.md)
 -   [aclnnRoundDecimals&aclnnInplaceRoundDecimals](./context/aclnnRoundDecimals&aclnnInplaceRoundDecimals.md)
 -   [aclnnRReluWithNoise&aclnnInplaceRReluWithNoise](./context/aclnnRReluWithNoise&aclnnInplaceRReluWithNoise.md)
 -   [aclnnRsqrt&aclnnInplaceRsqrt](./context/aclnnRsqrt&aclnnInplaceRsqrt.md)
 -   [aclnnRsub](./context/aclnnRsub.md)
 -   [aclnnRsubs](./context/aclnnRsubs.md)
 -   [aclnnScatter&aclnnInplaceScatter](./context/aclnnScatter&aclnnInplaceScatter.md)
 -   [aclnnScatterAdd](./context/aclnnScatterAdd.md)
 -   [aclnnScatterValue&aclnnInplaceScatterValue](./context/aclnnScatterValue&aclnnInplaceScatterValue.md)
 -   [aclnnSearchSorted](./context/aclnnSearchSorted.md)
 -   [aclnnSearchSorteds](./context/aclnnSearchSorteds.md)
 -   [aclnnSelu&aclnnInplaceSelu](./context/aclnnSelu&aclnnInplaceSelu.md)
 -   [aclnnSigmoid&aclnnInplaceSigmoid](./context/aclnnSigmoid&aclnnInplaceSigmoid.md)
 -   [aclnnSigmoidBackward](./context/aclnnSigmoidBackward.md)
 -   [aclnnSign](./context/aclnnSign.md)
 -   [aclnnSignbit](./context/aclnnSignbit.md)
 -   [aclnnSilu](./context/aclnnSilu.md)
 -   [aclnnSiluBackward](./context/aclnnSiluBackward.md)
 -   [aclnnSin&aclnnInplaceSin](./context/aclnnSin&aclnnInplaceSin.md)
 -   [aclnnSinc&aclnnInplaceSinc](./context/aclnnSinc&aclnnInplaceSinc.md)
 -   [aclnnSinh&aclnnInplaceSinh](./context/aclnnSinh&aclnnInplaceSinh.md)
 -   [aclnnSlice](./context/aclnnSlice.md)
 -   [aclnnSliceV2](./context/aclnnSliceV2.md)
 -   [aclnnSlogdet](./context/aclnnSlogdet.md)
 -   [aclnnSmoothL1Loss](./context/aclnnSmoothL1Loss.md)
 -   [aclnnSmoothL1LossBackward](./context/aclnnSmoothL1LossBackward.md)
 -   [aclnnSoftMarginLoss](./context/aclnnSoftMarginLoss.md)
 -   [aclnnSoftMarginLossBackward](./context/aclnnSoftMarginLossBackward.md)
 -   [aclnnSoftmax](./context/aclnnSoftmax.md)
 -   [aclnnSoftmaxBackward](./context/aclnnSoftmaxBackward.md)
 -   [aclnnSoftplus](./context/aclnnSoftplus.md)
 -   [aclnnSoftplusBackward](./context/aclnnSoftplusBackward.md)
 -   [aclnnSoftshrink](./context/aclnnSoftshrink.md)
 -   [aclnnSoftshrinkBackward](./context/aclnnSoftshrinkBackward.md)
 -   [aclnnSort](./context/aclnnSort.md)
 -   [aclnnSplitWithSize](./context/aclnnSplitWithSize.md)
 -   [aclnnSplitTensor](./context/aclnnSplitTensor.md)
 -   [aclnnSqrt&aclnnInplaceSqrt](./context/aclnnSqrt&aclnnInplaceSqrt.md)
 -   [aclnnStack](./context/aclnnStack.md)
 -   [aclnnStd](./context/aclnnStd.md)
 -   [aclnnStdMeanCorrection](./context/aclnnStdMeanCorrection.md)
 -   [aclnnSub&aclnnInplaceSub](./context/aclnnSub&aclnnInplaceSub.md)
 -   [aclnnSubs](./context/aclnnSubs.md)
 -   [aclnnSum](./context/aclnnSum.md)
 -   [aclnnSWhere](./context/aclnnSWhere.md)
 -   [aclnnTake](./context/aclnnTake.md)
 -   [aclnnTan&aclnnInplaceTan](./context/aclnnTan&aclnnInplaceTan.md)
 -   [aclnnTanh&aclnnInplaceTanh](./context/aclnnTanh&aclnnInplaceTanh.md)
 -   [aclnnTanhBackward](./context/aclnnTanhBackward.md)
 -   [aclnnThreshold](./context/aclnnThreshold.md)
 -   [aclnnThresholdBackward](./context/aclnnThresholdBackward.md)
 -   [aclnnTopk](./context/aclnnTopk.md)
 -   [aclnnTrace](./context/aclnnTrace.md)
 -   [aclnnTriangularSolve](./context/aclnnTriangularSolve.md)
 -   [aclnnTril&aclnnInplaceTril](./context/aclnnTril&aclnnInplaceTril.md)
 -   [aclnnTriu&aclnnInplaceTriu](./context/aclnnTriu&aclnnInplaceTriu.md)
 -   [aclnnTrunc&aclnnInplaceTrunc](./context/aclnnTrunc&aclnnInplaceTrunc.md)
 -   [aclnnInplaceUniform](./context/aclnnInplaceUniform.md)
 -   [aclnnUnique](./context/aclnnUnique.md)
 -   [aclnnUnique2](./context/aclnnUnique2.md)
 -   [aclnnUniqueConsecutive](./context/aclnnUniqueConsecutive.md)
 -   [aclnnUpsampleBilinear2d](./context/aclnnUpsampleBilinear2d.md)
 -   [aclnnUpsampleBilinear2dBackward](./context/aclnnUpsampleBilinear2dBackward.md)
 -   [aclnnUpsampleLinear1d](./context/aclnnUpsampleLinear1d.md)
 -   [aclnnUpsampleLinear1dBackward](./context/aclnnUpsampleLinear1dBackward.md)
 -   [aclnnUpsampleNearest1d](./context/aclnnUpsampleNearest1d.md)
 -   [aclnnUpsampleNearest1dBackward](./context/aclnnUpsampleNearest1dBackward.md)
 -   [aclnnUpsampleNearest2d](./context/aclnnUpsampleNearest2d.md)
 -   [aclnnUpsampleNearest2dBackward](./context/aclnnUpsampleNearest2dBackward.md)
 -   [aclnnUpsampleNearest3d](./context/aclnnUpsampleNearest3d.md)
 -   [aclnnUpsampleNearest3dBackward](./context/aclnnUpsampleNearest3dBackward.md)
 -   [aclnnUpsampleTrilinear3d](./context/aclnnUpsampleTrilinear3d.md)
 -   [aclnnUpsampleTrilinear3dBackward](./context/aclnnUpsampleTrilinear3dBackward.md)
 -   [aclnnVar](./context/aclnnVar.md)
 -   [aclnnVarCorrection](./context/aclnnVarCorrection.md)
 -   [aclnnVarMean](./context/aclnnVarMean.md)
 -   [aclnnXLogYScalarOther&aclnnInplaceXLogYScalarOther](./context/aclnnXLogYScalarOther&aclnnInplaceXLogYScalarOther.md)
 -   [aclnnXLogYScalarSelf](./context/aclnnXLogYScalarSelf.md)
 -   [aclnnXLogYTensor&aclnnInplaceXLogYTensor](./context/aclnnXLogYTensor&aclnnInplaceXLogYTensor.md)


## 编译与运行样例
 [编译与运行样例](./context/common/编译与运行样例.md)
